From 49e26b1b33f6efa169f27512e6e6e1d7dc911926 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Fri, 2 Jul 2021 14:40:39 +0000
Subject: [PATCH] [arm64] port luma_vsp

luma_vsp[  4x4]		11.60x 	 45.75    	 530.52
luma_vsp[  8x8]		23.38x 	 88.45    	 2068.45
luma_vsp[16x16]		25.67x 	 319.84   	 8211.73
luma_vsp[32x32]		25.81x 	 1270.65  	 32795.09
luma_vsp[64x64]		26.22x 	 4979.80  	 130588.90
luma_vsp[  8x4]		21.78x 	 47.56    	 1035.76
luma_vsp[  4x8]		12.36x 	 84.82    	 1048.42
luma_vsp[ 16x8]		25.24x 	 162.75   	 4107.63
luma_vsp[ 8x16]		24.45x 	 168.93   	 4129.50
luma_vsp[32x16]		25.79x 	 633.89   	 16348.89
luma_vsp[16x32]		20.65x 	 792.00   	 16358.50
luma_vsp[64x32]		26.22x 	 2497.17  	 65481.45
luma_vsp[32x64]		25.84x 	 2527.99  	 65335.37
luma_vsp[16x12]		25.57x 	 241.33   	 6170.74
luma_vsp[12x16]		18.49x 	 333.70   	 6168.96
luma_vsp[ 16x4]		24.34x 	 84.66    	 2060.40
luma_vsp[ 4x16]		12.80x 	 163.87   	 2097.70
luma_vsp[32x24]		25.64x 	 956.17   	 24517.71
luma_vsp[24x32]		25.95x 	 947.06   	 24572.95
luma_vsp[ 32x8]		25.61x 	 319.26   	 8174.82
luma_vsp[ 8x32]		24.53x 	 334.64   	 8210.24
luma_vsp[64x48]		26.10x 	 3738.44  	 97562.65
luma_vsp[48x64]		26.02x 	 3763.20  	 97907.82
luma_vsp[64x16]		26.20x 	 1248.78  	 32716.69
luma_vsp[16x64]		25.68x 	 1275.48  	 32754.26
---
 source/common/aarch64/asm-primitives.cpp |  67 ++--
 source/common/aarch64/ipfilter8.S        | 384 +++++++++++++++++++++++
 source/common/aarch64/ipfilter8.h        |  26 ++
 source/common/arm/ipfilter8.S            |   5 +-
 source/common/primitives.h               |   3 -
 source/test/testbench.cpp                |  15 -
 6 files changed, 438 insertions(+), 62 deletions(-)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 902b44f..a7f5bca 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -56,47 +56,6 @@ void interp_8tap_hv_pp_cpu(const pixel* src, intptr_t srcStride, pixel* dst, int
     primitives.pu[size].luma_vsp(immed + (halfFilterSize - 1) * immedStride, immedStride, dst, dstStride, idxY);
 }
 
-
-/* Temporary workaround because luma_vsp assembly primitive has not been completed
- * but interp_8tap_hv_pp_cpu uses mixed C primitive and assembly primitive.
- * Otherwise, segment fault occurs. */
-void setupAliasCPrimitives(EncoderPrimitives &cp, EncoderPrimitives &asmp, int cpuMask)
-{
-    if (cpuMask & X265_CPU_NEON)
-    {
-        asmp.pu[LUMA_8x4].luma_vsp   = cp.pu[LUMA_8x4].luma_vsp;
-        asmp.pu[LUMA_8x8].luma_vsp   = cp.pu[LUMA_8x8].luma_vsp;
-        asmp.pu[LUMA_8x16].luma_vsp  = cp.pu[LUMA_8x16].luma_vsp;
-        asmp.pu[LUMA_8x32].luma_vsp  = cp.pu[LUMA_8x32].luma_vsp;
-        asmp.pu[LUMA_12x16].luma_vsp = cp.pu[LUMA_12x16].luma_vsp;
-#if !AUTO_VECTORIZE || GCC_VERSION < GCC_5_1_0 /* gcc_version < gcc-5.1.0 */
-        asmp.pu[LUMA_16x4].luma_vsp  = cp.pu[LUMA_16x4].luma_vsp;
-        asmp.pu[LUMA_16x8].luma_vsp  = cp.pu[LUMA_16x8].luma_vsp;
-        asmp.pu[LUMA_16x12].luma_vsp = cp.pu[LUMA_16x12].luma_vsp;
-        asmp.pu[LUMA_16x16].luma_vsp = cp.pu[LUMA_16x16].luma_vsp;
-        asmp.pu[LUMA_16x32].luma_vsp = cp.pu[LUMA_16x32].luma_vsp;
-        asmp.pu[LUMA_16x64].luma_vsp = cp.pu[LUMA_16x64].luma_vsp;
-        asmp.pu[LUMA_32x16].luma_vsp = cp.pu[LUMA_32x16].luma_vsp;
-        asmp.pu[LUMA_32x24].luma_vsp = cp.pu[LUMA_32x24].luma_vsp;
-        asmp.pu[LUMA_32x32].luma_vsp = cp.pu[LUMA_32x32].luma_vsp;
-        asmp.pu[LUMA_32x64].luma_vsp = cp.pu[LUMA_32x64].luma_vsp;
-        asmp.pu[LUMA_48x64].luma_vsp = cp.pu[LUMA_48x64].luma_vsp;
-        asmp.pu[LUMA_64x16].luma_vsp = cp.pu[LUMA_64x16].luma_vsp;
-        asmp.pu[LUMA_64x32].luma_vsp = cp.pu[LUMA_64x32].luma_vsp;
-        asmp.pu[LUMA_64x48].luma_vsp = cp.pu[LUMA_64x48].luma_vsp;
-        asmp.pu[LUMA_64x64].luma_vsp = cp.pu[LUMA_64x64].luma_vsp;    
-#if !AUTO_VECTORIZE || GCC_VERSION < GCC_4_9_0 /* gcc_version < gcc-4.9.0 */
-        asmp.pu[LUMA_4x4].luma_vsp   = cp.pu[LUMA_4x4].luma_vsp;
-        asmp.pu[LUMA_4x8].luma_vsp   = cp.pu[LUMA_4x8].luma_vsp;
-        asmp.pu[LUMA_4x16].luma_vsp  = cp.pu[LUMA_4x16].luma_vsp;
-        asmp.pu[LUMA_24x32].luma_vsp = cp.pu[LUMA_24x32].luma_vsp;
-        asmp.pu[LUMA_32x8].luma_vsp  = cp.pu[LUMA_32x8].luma_vsp;
-#endif
-#endif
-    }
-}
-
-
 void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask) 
 {
     if (cpuMask & X265_CPU_NEON)
@@ -267,6 +226,32 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_24x32].luma_vpp   = PFX(interp_8tap_vert_pp_24x32_neon);
         p.pu[LUMA_48x64].luma_vpp   = PFX(interp_8tap_vert_pp_48x64_neon);
         p.pu[LUMA_12x16].luma_vpp   = PFX(interp_8tap_vert_pp_12x16_neon);
+
+        p.pu[LUMA_4x4].luma_vsp     = PFX(interp_8tap_vert_sp_4x4_neon);
+        p.pu[LUMA_4x8].luma_vsp     = PFX(interp_8tap_vert_sp_4x8_neon);
+        p.pu[LUMA_4x16].luma_vsp    = PFX(interp_8tap_vert_sp_4x16_neon);
+        p.pu[LUMA_8x4].luma_vsp     = PFX(interp_8tap_vert_sp_8x4_neon);
+        p.pu[LUMA_8x8].luma_vsp     = PFX(interp_8tap_vert_sp_8x8_neon);
+        p.pu[LUMA_8x16].luma_vsp    = PFX(interp_8tap_vert_sp_8x16_neon);
+        p.pu[LUMA_8x32].luma_vsp    = PFX(interp_8tap_vert_sp_8x32_neon);
+        p.pu[LUMA_16x4].luma_vsp    = PFX(interp_8tap_vert_sp_16x4_neon);
+        p.pu[LUMA_16x8].luma_vsp    = PFX(interp_8tap_vert_sp_16x8_neon);
+        p.pu[LUMA_16x16].luma_vsp   = PFX(interp_8tap_vert_sp_16x16_neon);
+        p.pu[LUMA_16x32].luma_vsp   = PFX(interp_8tap_vert_sp_16x32_neon);
+        p.pu[LUMA_16x64].luma_vsp   = PFX(interp_8tap_vert_sp_16x64_neon);
+        p.pu[LUMA_16x12].luma_vsp   = PFX(interp_8tap_vert_sp_16x12_neon);
+        p.pu[LUMA_32x8].luma_vsp    = PFX(interp_8tap_vert_sp_32x8_neon);
+        p.pu[LUMA_32x16].luma_vsp   = PFX(interp_8tap_vert_sp_32x16_neon);
+        p.pu[LUMA_32x32].luma_vsp   = PFX(interp_8tap_vert_sp_32x32_neon);
+        p.pu[LUMA_32x64].luma_vsp   = PFX(interp_8tap_vert_sp_32x64_neon);
+        p.pu[LUMA_32x24].luma_vsp   = PFX(interp_8tap_vert_sp_32x24_neon);
+        p.pu[LUMA_64x16].luma_vsp   = PFX(interp_8tap_vert_sp_64x16_neon);
+        p.pu[LUMA_64x32].luma_vsp   = PFX(interp_8tap_vert_sp_64x32_neon);
+        p.pu[LUMA_64x64].luma_vsp   = PFX(interp_8tap_vert_sp_64x64_neon);
+        p.pu[LUMA_64x48].luma_vsp   = PFX(interp_8tap_vert_sp_64x48_neon);
+        p.pu[LUMA_24x32].luma_vsp   = PFX(interp_8tap_vert_sp_24x32_neon);
+        p.pu[LUMA_48x64].luma_vsp   = PFX(interp_8tap_vert_sp_48x64_neon);
+        p.pu[LUMA_12x16].luma_vsp   = PFX(interp_8tap_vert_sp_12x16_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index b246497..ee9a73c 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -675,6 +675,383 @@ function x265_interp_8tap_vert_pp_12x16_neon
     cbnz            x5, .loop_vpp_12x16
     ret
 endfunc
+//**************luma_vsp************
+// void interp_vert_sp_c(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx)
+.macro LUMA_VSP_4xN h
+function x265_interp_8tap_vert_sp_4x\h\()_neon
+    lsl             x5, x4, #6
+    lsl             x1, x1, #1
+    lsl             x4, x1, #2
+    sub             x4, x4, x1
+    sub             x0, x0, x4
+
+    mov             w12, #1
+    lsl             w12, w12, #19
+    add             w12, w12, #2048
+    dup             v24.4s, w12
+    mov             x4, #\h
+.loop_vsp_4x\h:
+    movrel          x12, g_lumaFilter
+    add             x12, x12, x5
+    mov             x6, x0
+
+    ld1             {v0.8b}, [x6], x1
+    sshll           v0.4s, v0.4h, #0
+    ld1r            {v16.2d}, [x12], #8
+
+    ld1             {v1.8b}, [x6], x1
+    sshll           v1.4s, v1.4h, #0
+    ld1r            {v17.2d}, [x12], #8
+    mul             v0.4s, v0.4s, v16.4s
+
+    ld1             {v2.8b}, [x6], x1
+    sshll           v2.4s, v2.4h, #0
+    ld1r            {v18.2d}, [x12], #8
+    mla             v0.4s, v1.4s, v17.4s
+
+    ld1             {v3.8b}, [x6], x1
+    sshll           v3.4s, v3.4h, #0
+    ld1r            {v19.2d}, [x12], #8
+    mla             v0.4s, v2.4s, v18.4s
+
+    ld1             {v4.8b}, [x6], x1
+    sshll           v4.4s, v4.4h, #0
+    ld1r            {v20.2d}, [x12], #8
+    mla             v0.4s, v3.4s, v19.4s
+
+    ld1             {v5.8b}, [x6], x1
+    sshll           v5.4s, v5.4h, #0
+    ld1r            {v21.2d}, [x12], #8
+    mla             v0.4s, v4.4s, v20.4s
+
+    ld1             {v6.8b}, [x6], x1
+    sshll           v6.4s, v6.4h, #0
+    ld1r            {v22.2d}, [x12], #8
+    mla             v0.4s, v5.4s, v21.4s
+
+    ld1             {v7.8b}, [x6], x1
+    sshll           v7.4s, v7.4h, #0
+    ld1r            {v23.2d}, [x12], #8
+    mla             v0.4s, v6.4s, v22.4s
+
+    mla             v0.4s, v7.4s, v23.4s
+
+    add             v0.4s, v0.4s, v24.4s
+    sqshrun         v0.4h, v0.4s, #12
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.s}[0], [x2], x3
+
+    add             x0, x0, x1
+    sub             x4, x4, #1
+    cbnz            x4, .loop_vsp_4x\h
+    ret
+endfunc
+.endm
+
+LUMA_VSP_4xN 4
+LUMA_VSP_4xN 8
+LUMA_VSP_4xN 16
+
+        // input: v0, v1, v2, v3, v4, v5, v6, v7
+        // temp regs: v16, v19, v20, v21, v22, v23, v24
+        // result in v17.4s, v18.4s
+.macro qpel_filter_0_32b_1
+    movi            v24.8h, #64
+    smull           v17.4s, v3.4h, v24.4h    // 64*d0
+    smull2          v18.4s, v3.8h, v24.8h    // 64*d1
+.endm
+
+.macro qpel_filter_1_32b_1
+    movi            v16.8h, #58
+    movi            v24.8h, #10
+    smull           v17.4s, v3.4h, v16.4h    // 58 * d0
+    smull2          v18.4s, v3.8h, v16.8h    // 58 * d1
+    movi            v16.8h, #17
+    smull           v19.4s, v2.4h, v24.4h    // 10 * c0
+    smull2          v20.4s, v2.8h, v24.8h    // 10 * c1
+    movi            v24.8h, #5
+    smull           v21.4s, v4.4h, v16.4h    // 17 * e0
+    smull2          v22.4s, v4.8h, v16.8h    // 17 * e1
+    smull           v23.4s, v5.4h, v24.4h    //  5 * f0
+    smull2          v16.4s, v5.8h, v24.8h    //  5 * f1
+    sub             v17.4s, v17.4s, v19.4s   // 58 * d0 - 10 * c0
+    sub             v18.4s, v18.4s, v20.4s   // 58 * d1 - 10 * c1
+    sshll           v19.4s, v1.4h, #2        // 4 * b0
+    sshll2          v20.4s, v1.8h, #2        // 4 * b1
+    add             v17.4s, v17.4s, v21.4s   // 58 * d0 - 10 * c0 + 17 * e0
+    add             v18.4s, v18.4s, v22.4s   // 58 * d1 - 10 * c1 + 17 * e1
+    ssubl           v21.4s, v6.4h, v0.4h     // g0 - a0
+    ssubl2          v22.4s, v6.8h, v0.8h     // g1 - a1
+    add             v17.4s, v17.4s, v19.4s   // 58 * d0 - 10 * c0 + 17 * e0 + 4 * b0
+    add             v18.4s, v18.4s, v20.4s   // 58 * d1 - 10 * c1 + 17 * e1 + 4 * b1
+    sub             v21.4s, v21.4s, v23.4s   // g0 - a0 - 5 * f0
+    sub             v22.4s, v22.4s, v16.4s   // g1 - a1 - 5 * f1
+    add             v17.4s, v17.4s, v21.4s   // 58 * d0 - 10 * c0 + 17 * e0 + 4 * b0 + g0 - a0 - 5 * f0
+    add             v18.4s, v18.4s, v22.4s   // 58 * d1 - 10 * c1 + 17 * e1 + 4 * b1 + g1 - a1 - 5 * f1
+.endm
+
+.macro qpel_filter_2_32b_1
+    movi            v16.4s, #11
+    saddl           v17.4s, v3.4h, v4.4h     // d0 + e0
+    saddl2          v18.4s, v3.8h, v4.8h     // d1 + e1
+    saddl           v19.4s, v2.4h, v5.4h     // c0 + f0
+    saddl2          v20.4s, v2.8h, v5.8h     // c1 + f1
+    mul             v19.4s, v19.4s, v16.4s   // 11 * (c0 + f0)
+    mul             v20.4s, v20.4s, v16.4s   // 11 * (c1 + f1)
+    movi            v16.4s, #40
+    saddl           v23.4s, v1.4h, v6.4h     // b0 + g0
+    mul             v17.4s, v17.4s, v16.4s   // 40 * (d0 + e0)
+    mul             v18.4s, v18.4s, v16.4s   // 40 * (d1 + e1)
+    saddl2          v16.4s, v1.8h, v6.8h     // b1 + g1
+    saddl           v21.4s, v0.4h, v7.4h     // a0 + h0
+    saddl2          v22.4s, v0.8h, v7.8h     // a1 + h1
+    shl             v23.4s, v23.4s, #2       // 4*(b0+g0)
+    shl             v16.4s, v16.4s, #2       // 4*(b1+g1)
+    add             v19.4s, v19.4s, v21.4s   // 11 * (c0 + f0) + a0 + h0
+    add             v20.4s, v20.4s, v22.4s   // 11 * (c1 + f1) + a1 + h1
+    add             v17.4s, v17.4s, v23.4s   // 40 * (d0 + e0) + 4*(b0+g0)
+    add             v18.4s, v18.4s, v16.4s   // 40 * (d1 + e1) + 4*(b1+g1)
+    sub             v17.4s, v17.4s, v19.4s   // 40 * (d0 + e0) + 4*(b0+g0) - (11 * (c0 + f0) + a0 + h0)
+    sub             v18.4s, v18.4s, v20.4s   // 40 * (d1 + e1) + 4*(b1+g1) - (11 * (c1 + f1) + a1 + h1)
+.endm
+
+.macro qpel_filter_3_32b_1
+    movi            v16.8h, #17
+    movi            v24.8h, #5
+    smull           v17.4s, v3.4h, v16.4h    // 17 * d0
+    smull2          v18.4s, v3.8h, v16.8h    // 17 * d1
+    movi            v16.8h, #58
+    smull           v19.4s, v2.4h, v24.4h    //  5 * c0
+    smull2          v20.4s, v2.8h, v24.8h    //  5 * c1
+    movi            v24.8h, #10
+    smull           v21.4s, v4.4h, v16.4h    // 58 * e0
+    smull2          v22.4s, v4.8h, v16.8h    // 58 * e1
+    smull           v23.4s, v5.4h, v24.4h    // 10 * f0
+    smull2          v16.4s, v5.8h, v24.8h    // 10 * f1
+    sub             v17.4s, v17.4s, v19.4s   // 17 * d0 - 5 * c0
+    sub             v18.4s, v18.4s, v20.4s   // 17 * d1 - 5 * c1
+    sshll           v19.4s, v6.4h, #2        //  4 * g0
+    sshll2          v20.4s, v6.8h, #2        //  4 * g1
+    add             v17.4s, v17.4s, v21.4s   // 17 * d0 - 5 * c0 + 58 * e0
+    add             v18.4s, v18.4s, v22.4s   // 17 * d1 - 5 * c1 + 58 * e1
+    ssubl           v21.4s, v1.4h, v7.4h     // b0 - h0
+    ssubl2          v22.4s, v1.8h, v7.8h     // b1 - h1
+    add             v17.4s, v17.4s, v19.4s   // 17 * d0 - 5 * c0 + 58 * e0 + 4 * g0
+    add             v18.4s, v18.4s, v20.4s   // 17 * d1 - 5 * c1 + 58 * e1 + 4 * g1
+    sub             v21.4s, v21.4s, v23.4s   // b0 - h0 - 10 * f0
+    sub             v22.4s, v22.4s, v16.4s   // b1 - h1 - 10 * f1
+    add             v17.4s, v17.4s, v21.4s   // 17 * d0 - 5 * c0 + 58 * e0 + 4 * g0 + b0 - h0 - 10 * f0
+    add             v18.4s, v18.4s, v22.4s   // 17 * d1 - 5 * c1 + 58 * e1 + 4 * g1 + b1 - h1 - 10 * f1
+.endm
+
+.macro FILTER_VSP a b filterv
+    mov             w12, #1
+    lsl             w12, w12, #19
+    add             w12, w12, #2048
+    dup             v30.4s, w12
+.loop_\filterv\()_\a\()x\b:
+
+    mov             x7, x2
+    mov             x9, #0
+
+.loop_w8_\filterv\()_\a\()x\b:
+
+    add             x6, x0, x9
+
+    ld1             {v0.8h}, [x6], x1
+    ld1             {v1.8h}, [x6], x1
+    ld1             {v2.8h}, [x6], x1
+    ld1             {v3.8h}, [x6], x1
+    ld1             {v4.8h}, [x6], x1
+    ld1             {v5.8h}, [x6], x1
+    ld1             {v6.8h}, [x6], x1
+    ld1             {v7.8h}, [x6], x1
+
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+
+   \filterv
+
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #12
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #12
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x7], #8
+
+    add             x9, x9, #16
+    mov             x12, #\a
+    lsl             x12, x12, #1
+    cmp             x9, x12
+    blt             .loop_w8_\filterv\()_\a\()x\b
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop_\filterv\()_\a\()x\b
+.endm
+
+.macro LUMA_VSP  w h
+function x265_interp_8tap_vert_sp_\w\()x\h\()_neon
+    lsl             x1, x1, #1
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5
+    mov             x5, #\h
+
+    cmp             x4, #0
+    beq             0f
+    cmp             x4, #1
+    beq             1f
+    cmp             x4, #2
+    beq             2f
+    cmp             x4, #3
+    beq             3f
+0:
+    FILTER_VSP  \w \h qpel_filter_0_32b_1
+    ret
+1:
+    FILTER_VSP  \w \h qpel_filter_1_32b_1
+    ret
+2:
+    FILTER_VSP  \w \h qpel_filter_2_32b_1
+    ret
+3:
+    FILTER_VSP  \w \h qpel_filter_3_32b_1
+    ret
+endfunc
+.endm
+
+
+LUMA_VSP 8 4
+LUMA_VSP 8 8
+LUMA_VSP 8 16
+LUMA_VSP 8 32
+LUMA_VSP 16 4
+LUMA_VSP 16 8
+LUMA_VSP 16 16
+LUMA_VSP 16 32
+LUMA_VSP 16 64
+LUMA_VSP 16 12
+LUMA_VSP 32 8
+LUMA_VSP 32 16
+LUMA_VSP 32 32
+LUMA_VSP 32 64
+LUMA_VSP 32 24
+LUMA_VSP 64 16
+LUMA_VSP 64 32
+LUMA_VSP 64 64
+LUMA_VSP 64 48
+LUMA_VSP 24 32
+LUMA_VSP 48 64
+
+function x265_interp_8tap_vert_sp_12x16_neon
+    lsl             x1, x1, #1
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5
+    sub             x3, x3, #12
+    mov             x5, #16
+
+    mov             w12, #1
+    lsl             w12, w12, #19
+    add             w12, w12, #2048
+    dup             v30.4s, w12
+
+.loop1_12x16:
+    mov             x6, x0
+
+    ld1             {v0.8h}, [x6], x1
+    ld1             {v1.8h}, [x6], x1
+    ld1             {v2.8h}, [x6], x1
+    ld1             {v3.8h}, [x6], x1
+    ld1             {v4.8h}, [x6], x1
+    ld1             {v5.8h}, [x6], x1
+    ld1             {v6.8h}, [x6], x1
+    ld1             {v7.8h}, [x6], x1
+
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+
+    cmp             x4, #0
+    beq             0f
+    cmp             x4, #1
+    beq             1f
+    cmp             x4, #2
+    beq             2f
+    cmp             x4, #3
+    beq             3f
+0:
+    qpel_filter_0_32b_1
+    b            5f
+1:
+    qpel_filter_1_32b_1
+    b            5f
+2:
+    qpel_filter_2_32b_1
+    b            5f
+3:
+    qpel_filter_3_32b_1
+    b            5f
+5:
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #12
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #12
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x2], #8
+
+    add             x6, x0, #16
+
+    ld1             {v0.8h}, [x6], x1
+    ld1             {v1.8h}, [x6], x1
+    ld1             {v2.8h}, [x6], x1
+    ld1             {v3.8h}, [x6], x1
+    ld1             {v4.8h}, [x6], x1
+    ld1             {v5.8h}, [x6], x1
+    ld1             {v6.8h}, [x6], x1
+    ld1             {v7.8h}, [x6], x1
+
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+
+    cmp             x4, #0
+    beq             0f
+    cmp             x4, #1
+    beq             1f
+    cmp             x4, #2
+    beq             2f
+    cmp             x4, #3
+    beq             3f
+0:
+    qpel_filter_0_32b_1
+    b            5f
+1:
+    qpel_filter_1_32b_1
+    b            5f
+2:
+    qpel_filter_2_32b_1
+    b            5f
+3:
+    qpel_filter_3_32b_1
+    b            5f
+5:
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #12
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #12
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.s}[0], [x2], #4
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop1_12x16
+    ret
+endfunc
 
 .macro vextin8
     ld1             {v3.16b}, [x11], #16
@@ -923,3 +1300,10 @@ const g_luma_s16, align=8
 .hword  -1, 4, -11, 40, 40, -11, 4, -1
 .hword   0, 1,  -5, 17, 58, -10, 4, -1
 endconst
+
+const g_lumaFilter, align=8
+.word 0,0,0,0,0,0,64,64,0,0,0,0,0,0,0,0
+.word -1,-1,4,4,-10,-10,58,58,17,17,-5,-5,1,1,0,0
+.word -1,-1,4,4,-11,-11,40,40,40,40,-11,-11,4,4,-1,-1
+.word 0,0,1,1,-5,-5,17,17,58,58,-10,-10,4,4,-1,-1
+endconst
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index fd724aa..04e6e4d 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -76,6 +76,32 @@ void x265_interp_8tap_vert_pp_24x32_neon(const pixel* src, intptr_t srcStride, p
 void x265_interp_8tap_vert_pp_48x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 void x265_interp_8tap_vert_pp_12x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 
+void x265_interp_8tap_vert_sp_4x4_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_4x8_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_4x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_8x4_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_8x8_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_8x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_8x32_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_16x4_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_16x8_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_16x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_16x32_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_16x64_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_16x12_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_32x8_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_32x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_32x32_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_32x64_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_32x24_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_64x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_64x32_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_64x64_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_64x48_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_24x32_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_48x64_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_sp_12x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
diff --git a/source/common/arm/ipfilter8.S b/source/common/arm/ipfilter8.S
index c6ac166..3a45942 100644
--- a/source/common/arm/ipfilter8.S
+++ b/source/common/arm/ipfilter8.S
@@ -1360,8 +1360,8 @@ LUMA_VSP_4xN 16
     vsubl.s16       q14, d3, d15  // b1 - h1
     vadd.s32        q9, q11       // 17 * d0 - 5 * c0+ 58 * e0 +4 * g0
     vadd.s32        q10, q12      // 17 * d1 - 5 * c1 + 58 * e1+4 * g1
-    vsub.s32        q13, q15      // 17 * d0 - 5 * c0+ 58 * e0 +4 * g0 -10 * f0
-    vsub.s32        q14, q8       // 17 * d1 - 5 * c1 + 58 * e1+4 * g1 - 10*f1
+    vsub.s32        q13, q15      // b0 - h0 - 10 * f0
+    vsub.s32        q14, q8       // b1 - h1 - 10 * f1
     vadd.s32        q9, q13       //  17 * d0 - 5 * c0+ 58 * e0 +4 * g0 -10 * f0 +b0 - h0
     vadd.s32        q10, q14      // 17 * d1 - 5 * c1 + 58 * e1+4 * g1 - 10*f1 + b1 - h1
 .endm
@@ -1372,7 +1372,6 @@ LUMA_VSP_4xN 16
 .loop_\filterv\()_\a\()x\b:
 
     mov             r7, r2
-    mov             r6, r0
     eor             r8, r8
 
 .loop_w8_\filterv\()_\a\()x\b:
diff --git a/source/common/primitives.h b/source/common/primitives.h
index 0b52f84..bd6ff9e 100644
--- a/source/common/primitives.h
+++ b/source/common/primitives.h
@@ -469,9 +469,6 @@ void setupCPrimitives(EncoderPrimitives &p);
 void setupInstrinsicPrimitives(EncoderPrimitives &p, int cpuMask);
 void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask);
 void setupAliasPrimitives(EncoderPrimitives &p);
-#if X265_ARCH_ARM64
-void setupAliasCPrimitives(EncoderPrimitives &cp, EncoderPrimitives &asmp, int cpuMask);
-#endif
 #if HAVE_ALTIVEC
 void setupPixelPrimitives_altivec(EncoderPrimitives &p);
 void setupDCTPrimitives_altivec(EncoderPrimitives &p);
diff --git a/source/test/testbench.cpp b/source/test/testbench.cpp
index 8db8c0c..d4fbe21 100644
--- a/source/test/testbench.cpp
+++ b/source/test/testbench.cpp
@@ -209,14 +209,6 @@ int main(int argc, char *argv[])
         EncoderPrimitives asmprim;
         memset(&asmprim, 0, sizeof(asmprim));
         setupAssemblyPrimitives(asmprim, test_arch[i].flag);
-
-#if X265_ARCH_ARM64
-        /* Temporary workaround because luma_vsp assembly primitive has not been completed
-         * but interp_8tap_hv_pp_cpu uses mixed C primitive and assembly primitive.
-         * Otherwise, segment fault occurs. */
-        setupAliasCPrimitives(cprim, asmprim, test_arch[i].flag);
-#endif
-
         setupAliasPrimitives(asmprim);
         memcpy(&primitives, &asmprim, sizeof(EncoderPrimitives));
         for (size_t h = 0; h < sizeof(harness) / sizeof(TestHarness*); h++)
@@ -241,13 +233,6 @@ int main(int argc, char *argv[])
 #endif
     setupAssemblyPrimitives(optprim, cpuid);
 
-#if X265_ARCH_ARM64
-    /* Temporary workaround because luma_vsp assembly primitive has not been completed
-     * but interp_8tap_hv_pp_cpu uses mixed C primitive and assembly primitive.
-     * Otherwise, segment fault occurs. */
-    setupAliasCPrimitives(cprim, optprim, cpuid);
-#endif
-
     /* Note that we do not setup aliases for performance tests, that would be
      * redundant. The testbench only verifies they are correctly aliased */
 
-- 
2.25.1

